
program Hanxx_xx;
{$X+}
{$R spiralen.RES}

{Besonderheiten:

 Stand: 04. 12. 1992


 noch zu implementieren:

 - Schnelligkeit erhhen

 - Vergrerungsmen: noch keine proportionale nderung

 - neue Farbe whlen --> Matrix in Prozedur

 - Arbeitsicone --> Spiralenbild Ei und Spirale
}

uses Strings, WinTypes, WinProcs, WObjects, StdDlgs;


{--------------------------------------------------}
{ Konstanten-Vereinbarung                          }
{--------------------------------------------------}

const
  cn_Archimedes       = 1;
  cn_Hyperbolisch     = 2;
  cn_Logarithmisch    = 3;

  cn_rot              = $000000FF;
  cn_schwarz          = $00000000;
  cn_blau             = $00FF0000;
  cn_gruen            = $0000FF00;

  cm_Archimedes      = 200;
  cm_Logarithmisch   = 201;
  cm_Hyperbolisch    = 202;
 
  cm_Spirkonstante   = 101;
  cm_Ueberlagerung   = 102;
  cm_Hilfe_Index     = 301;



{--------------------------------------------------}
{ Typen-Vereinbarungen                             }
{--------------------------------------------------}
type               
  TMyApplication = object(TApplication)
    procedure InitMainWindow; virtual;
  end;

type
  PMyWindow = ^TMyWindow;
  TMyWindow = object(TWindow)
    DragDC, MemDC: HDC;
    Anfangsbild: HBitmap;
    ButtonDown:  Boolean;
    IntrReq,
    ThePen: HPen;
    PenSize: Integer;
    MausPos: TPoint;
    Points: PCollection;

    constructor Init(AParent: PWindowsObject; ATitle: PChar);
    destructor Done; virtual;
    procedure GetWindowClass(var WndClass: TWndClass); virtual;
    procedure Paint(PaintDC: HDC; var PaintInfo: TPaintStruct); virtual;
    procedure   Hyperbolisch (var Msg: TMessage);
      virtual cm_First + cm_Hyperbolisch;
    procedure   Archimedes (var Msg: TMessage);
      virtual cm_First + cm_Archimedes;
    procedure   Logarithmisch (var Msg: TMessage);
      virtual cm_First + cm_Logarithmisch; 
    procedure GibNeueFensterMetrik (Maximum: Integer;
                                    var Hoehe, Breite: Integer;
                                    var Faktor: Real);
    procedure InitZeichnen;
    procedure SetzePunktundMaus;
    procedure SetzeUeberlagerung(var Msg: TMessage);
       virtual cm_First + cm_Ueberlagerung;
    procedure SpiralenkonstanteAendern(var Msg: TMessage);
       virtual cm_First + cm_Spirkonstante;
    procedure   Hilfe_Index (var Msg: TMessage);
       virtual cm_First + cm_Hilfe_Index;
  end;

type
    tPunkt       = RECORD
                      x,y: Real
                   END;

 { ------------------------------------ }
 { -- Globale Variablen              -- }
 { ------------------------------------ }
var
    Wnd          : HWnd;       {fr Abfragefenster: Zeichnung speichern}
    Auswahl      : Integer;    {cn_Archimedes u.a.}
    SpirConst    : Integer;
    farbe, f     : integer;
    r,x,y        : real;
    Punkte       : ARRAY [-360..2160]  OF tPunkt;

    WndBreite    : Integer;       {zum Zentrieren der Spiralen  }
    WndHoehe     : Integer;
    MenuHoehe    : Integer;
    Streckung    : Real;
    Ueberlagerung: Boolean;
    Icon         : HIcon;
    OldCursor,
    NewCursor    : HCursor;


{--------------------------------------------------}
{ TMyWindow's method implementations: Init        }
{--------------------------------------------------}
constructor TMyWindow.Init(AParent: PWindowsObject; ATitle: PChar);
begin
  Auswahl:= 0; {Initialisierung}
  SpirConst:= 495;
  farbe:= cn_schwarz;
  HWindow:= GetDC (DragDC);
  TWindow.Init(AParent, ATitle);

  Attr.Menu := LoadMenu(HInstance, 'SPIRALENMENU');
  ButtonDown := False;
  Ueberlagerung:= FALSE;
  PenSize := 3;
  ThePen := CreatePen(ps_Solid, PenSize, 0);
  SelectObject (DragDC, ThePen);
  Points := New(PCollection, Init(50, 50));

  Attr.X:= 0; Attr.Y:= 0;                   {Fensterbeginn links oben}
  WndBreite:= GetSystemMetrics (sm_CXScreen);
  Attr.W:= WndBreite;
  MenuHoehe:=GetSystemMetrics (sm_CYCaption) +
             GetSystemMetrics (sm_CYBorder)+
             GetSystemMetrics (sm_CYMenu);
 
  WndHoehe:=GetSystemMetrics (sm_CYScreen) -   {Fensterhoehe=       }
           (GetSystemMetrics (sm_CYCaption) +  {HoeheBildschirm -   }
            GetSystemMetrics (sm_CYMenu)+      {Platz fuer Symbole  }
            GetSystemMetrics (sm_CYBorder))-
           (GetSystemMetrics (sm_CYIcon) +
            GetSystemMetrics (sm_CYMenu));

  Attr.H:= GetSystemMetrics (sm_CYScreen) -
          (GetSystemMetrics (sm_CYIcon) +
           GetSystemMetrics (sm_CYMenu));
end;


{--------------------------------------------------}
{     }
{         }
{--------------------------------------------------}

procedure TMyWindow.GetWindowClass(var WndClass: TWndClass);
begin
  TWindow.GetWindowClass(WndClass);
  WndClass.HIcon := LoadIcon(HInstance, 'ICON_2');

end;


{--------------------------------------------------}
{ Berechnung des Streckungsfaktors, um Spiralen    }
{ in Fenster beliebiger Gre zu zeichnen          }
{--------------------------------------------------}
procedure TMyWindow.GibNeueFensterMetrik (Maximum: Integer;
                                          var Hoehe, Breite:Integer;
                                          var Faktor: Real);
begin

  r:=Maximum/SpirConst;  {Wert maximaler Fenstergre}
  Punkte[Maximum].x:= r*cos(f*pi/180);  
  Punkte[Maximum-90].y:= r*sin(f*pi/180);

  Hoehe:= PWindow(Application^.MainWindow)^.Attr.H - MenuHoehe;
  Breite:= PWindow(Application^.MainWindow)^.Attr.W;

  if Breite > Hoehe then
     Faktor:= -Hoehe / (2*Punkte[Maximum].x-21.5) {maximale Hoehe}
  else
     Faktor:= -Breite / (2*Punkte[Maximum].y-20); {maximaleBreite}
 
end; {GibNeueFensterMetrik}


{--------------------------------------------------}
{ Lscht Anfangsbild                               }
{--------------------------------------------------}
procedure TMyWindow.InitZeichnen;
begin
  DragDC:= GetDC (HWindow);
  GibNeueFensterMetrik (2160, WndHoehe, WndBreite, Streckung);

  {Lschen des gezeichneten Bildschirms, wenn  keine Ueberlagerung}
  if Ueberlagerung then

  else begin
    BitBlt(DragDC, 0, 0, WndBreite, WndHoehe, 0, 0, 0, Whiteness);
  end;

  {Laden des Cursors : Bleistift aus Ressource                   }
  NewCursor:= LoadCursor (HInstance, 'CURSOR_2');
  OldCursor:= SetCursor (NewCursor);
 end;


{--------------------------------------------------}
{ Zeichnet einzelnen Punkt und Mauszeiger "Stift"  }
{--------------------------------------------------}
procedure TMyWindow.SetzePunktundMaus;
begin
  MausPos.x:= round((Streckung*Punkte[f].x + WndBreite/2));
  MausPos.y:= round((WndHoehe/2-(Streckung*Punkte[f].y)));
  setpixel(DragDC, MausPos.x, MausPos.y, farbe);

  {Zeichnen der Maus nach Pixel setzen, sonst flimmert MausZeiger}
  ClientToScreen (HWindow, MausPos);
  SetCursorPos (MausPos.x, MausPos.y);
  end;
  

{--------------------------------------------------}
{ Beenden der Anwendung                            }
{--------------------------------------------------}
destructor TMyWindow.Done;
begin
  Dispose(Points, Done);
  DeleteObject(ThePen);
  DeleteObject (Anfangsbild);
  TWindow.Done;
end;


{------------------------------------}
{ berlagerungsmodus initialisieren  }
{------------------------------------}
procedure TMyWindow.SetzeUeberlagerung(var Msg: TMessage);
begin
  IF CheckMenuItem (Attr.Menu, cm_Ueberlagerung, mf_Checked) THEN
  begin
    Ueberlagerung:= FALSE;
    farbe:= cn_schwarz;
    CheckMenuItem (Attr.Menu, cm_Ueberlagerung, mf_Unchecked);
  end
  else
  begin
    Ueberlagerung:= TRUE;
    CheckMenuItem (Attr.Menu, cm_Ueberlagerung, mf_Checked);
  end {if};
end;


{----------------------------------}
{ nderung der Spiralenkonstanten  }
{----------------------------------}
procedure TMyWindow.SpiralenkonstanteAendern(var Msg: TMessage);
var
  InputText: array[0..5] of Char;
  NewConst, ErrorPos: Integer;
begin
  Str(SpirConst, InputText);
  if Application^.ExecDialog(New(PInputDialog,
     Init(@Self, 'Spiralenkonstante', 'Eingabe einer neuen Konstanten:',
          InputText, SizeOf(InputText)))) = id_Ok then
  begin
    Val(InputText, NewConst, ErrorPos);
    if ErrorPos = 0 then SpirConst:= NewConst; {Archimedes}
  end;
end;


{-------------------------------------------------------------}
{ Neuzeichnen Fensterinhalt bei nderung des Fensters.        }
{ Zum Zeichnen der Spiralen wird der Wert aus dem Feld Punkte }
{ mit dem Streckungsfaktor multipliziert.                     }
{ Zeichnen des Anfangsbildes.                                 }
{-------------------------------------------------------------}
procedure TMyWindow.Paint(PaintDC: HDC; var PaintInfo: TPaintStruct);

procedure PaintArchimedes; far;
begin

  GibNeueFensterMetrik (2160, WndHoehe, WndBreite, Streckung);
  for f:=0 to 2160 do
      setpixel(PaintDC,
               round((Streckung*Punkte[f].x + WndBreite/2)),
               round((WndHoehe/2-(Streckung*Punkte[f].y))),
               farbe);
end;

procedure PaintHyperbolisch; far;

begin
  GibNeueFensterMetrik (1800, WndHoehe, WndBreite, Streckung);
  for f:=35 to 1800 do
      setpixel(PaintDC,
               round((Streckung*Punkte[f].x + WndBreite/2)),
               round((WndHoehe-(Streckung*Punkte[f].y + WndHoehe/2))),
               farbe);
end;  {Hyperbolisch}


procedure PaintLogarithmisch; far;
begin
  GibNeueFensterMetrik (1080, WndHoehe, WndBreite, Streckung);
  for f:=-360 to 1080 do
      setpixel(PaintDC,
               round((Streckung*Punkte[f].x + WndBreite/2)),
               round((WndHoehe-(Streckung*Punkte[f].y + WndHoehe/2))),
               farbe);
end;

{--------------------------------------------------}
{ Prozedurbeginn von Paint                         }
{--------------------------------------------------}
var
  aktuelleWndBreite,
  aktuelleWndHoehe:  INTEGER;
  MemoryDC: HDC;
begin {Paint}
  case Auswahl of
    0:                  {Zeichnen des Anfangsbildes              }
      begin
        Anfangsbild:= LoadBitmap (HInstance, 'BITMAP_1');
        MemoryDC := CreateCompatibleDC(PaintDC);
        SelectObject (MemoryDC, Anfangsbild);
        BitBlt(PaintDC, 100, 50, 567, 302, MemoryDC, 0, 0, srcCopy);
        SelectObject(MemoryDC, Anfangsbild);
        DeleteDC(MemoryDC);
      end;
    cn_Archimedes:    PaintArchimedes;
    cn_Hyperbolisch:  PaintHyperbolisch;
    cn_Logarithmisch: PaintLogarithmisch;
  end;
end; {Paint}


{--------------------------------------------------}
{ Zeichnen der hyperbolischen Spirale              }
{--------------------------------------------------}
procedure   TMyWindow.Hyperbolisch (var Msg: TMessage);
begin
  Auswahl:= cn_Hyperbolisch;
  InitZeichnen;
  for f:=35 to 1800 do
   begin
     r:=360/f;
     Punkte[f].x:=r*cos(f*pi/180);
     Punkte[f].y:=r*sin(f*pi/180);
     SetzePunktundMaus;
   end;
 SetCursor (OldCursor);
 ReleaseDC (HWindow, DragDC);
end; {Hyperbolisch}


{--------------------------------------------------}
{ Zeichnen der Archimedischen Spirale              }
{--------------------------------------------------}
procedure   TMyWindow.Archimedes (var Msg: TMessage) ;
begin
  Auswahl:= cn_Archimedes;
  InitZeichnen;
   for f:=0 to 2160 do
    begin
      r:=f/SpirConst;
      Punkte[f].x:= r*cos(f*pi/180);
      Punkte[f].y:= r*sin(f*pi/180);
      SetzePunktundMaus;
    end;
   SetCursor (OldCursor);
   ReleaseDC (HWindow, DragDC);
end;


{--------------------------------------------------}
{ Zeichnen der logarithmischen Spirale             }
{--------------------------------------------------}
procedure   TMyWindow.Logarithmisch (var Msg: TMessage) ;
begin
  Auswahl:= cn_Logarithmisch;
  InitZeichnen;
  for f:=-360 to 1080 do
    begin
      r:=exp(f/360-1);
      Punkte[f].x:=r*cos(f*pi/180);
      Punkte[f].y:=r*sin(f*pi/180);
      SetzePunktundMaus;
    end;
  SetCursor (OldCursor);
  ReleaseDC (HWindow, DragDC);
end;


{--------------------------------------------------}
{ Aufrufen der Hilfefunktion                       }
{--------------------------------------------------}
procedure   TMyWindow.Hilfe_Index (var Msg: TMessage);
begin
  WinHelp ( Wnd,'spiralen.hlp', Help_Index, 0);
end;


{--------------------------------------------------}
{ TMyApplication: Initialisieren                   }
{--------------------------------------------------}
procedure TMyApplication.InitMainWindow;
begin
  MainWindow := New(PMyWindow, Init(nil, 'Spiraliges'));
end;
 

{--------------------------------------------------}
{ Main program:                                    }
{--------------------------------------------------}
var
  MyApp : TMyApplication;
begin
  MyApp.Init('MyProgram');
  MyApp.Run;
  MyApp.Done;
end.
